/******************************************************************************
*
*   This file is part of the software tool "Cervix Image Processing 2 (CIP2)".
*
*   Author: Christoph Bergmeir
*   Supervisor: José M. Benítez
*   Copyright (c) DiCITS Lab, Sci2s group, DECSAI, University of Granada.
*
*   This program is free software; you can redistribute it and/or
*   modify it under the terms of the GNU General Public License
*   as published by the Free Software Foundation; either version 2
*   of the License, or (at your option) any later version.
*   
*   This program is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*   
*   You should have received a copy of the GNU General Public License
*   along with this program; if not, write to the Free Software
*   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
*   MA  02110-1301, USA.
*
******************************************************************************/

#include "itkImage.h"
#include "itkImageFileReader.h"
#include "itkImageFileWriter.h"

#include <cv.hpp>
#include <highgui.h>


void ConvertCVImageToITKImage(IplImage* inCvImg, itk::Image< unsigned char,  2 >::Pointer &outItkImage)
{
  cvSaveImage( "_____temp.png", inCvImg );

  typedef  unsigned char  PixelType;
  typedef itk::Image< PixelType,  2 >   ImageType;

  typedef itk::ImageFileReader< ImageType >  ReaderType;
  ReaderType::Pointer reader = ReaderType::New();
  reader->SetFileName( "_____temp.png" );
  reader->Update();

  outItkImage = reader->GetOutput();
}

int main( int argc, char * argv[] )
{

  IplImage* img;
  img=cvLoadImage( argv[1], CV_LOAD_IMAGE_UNCHANGED );

  typedef  unsigned char  PixelType;
  typedef itk::Image< PixelType,  2 >   ImageType;

  typedef itk::ImageFileWriter< ImageType >  WriterType;

  ImageType::Pointer itkImage = ImageType::New();

  ConvertCVImageToITKImage( img, itkImage);

  WriterType::Pointer writer = WriterType::New();

  writer->SetInput(itkImage);
  writer->SetFileName( argv[2] );
  writer->Update();

  return EXIT_SUCCESS;

  //typedef itk::ImageFileReader< ImageType >  ReaderType;
  //ReaderType::Pointer reader = ReaderType::New();
  //writer->SetInput( reader->GetOutput() );
  //reader->SetFileName( argv[1] );

  //cvSaveImage( argv[2], pimg );

}

