/******************************************************************************
*
*   This file is part of the software tool "Cervix Image Processing 2 (CIP2)".
*
*   Author: Christoph Bergmeir
*   Supervisor: José M. Benítez
*   Copyright (c) DiCITS Lab, Sci2s group, DECSAI, University of Granada.
*
*   This program is free software; you can redistribute it and/or
*   modify it under the terms of the GNU General Public License
*   as published by the Free Software Foundation; either version 2
*   of the License, or (at your option) any later version.
*   
*   This program is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*   
*   You should have received a copy of the GNU General Public License
*   along with this program; if not, write to the Free Software
*   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
*   MA  02110-1301, USA.
*
******************************************************************************/

//#include <string>
#include <iostream>

#include <cv.h>
#include <highgui.h>
#include <math.h>

int main(int argc, char** argv)
{
  IplImage* src;
  if((src=cvLoadImage(argv[1], 0))!= 0)
  {

    IplImage* dst = cvCreateImage( cvGetSize(src), 8, 3 );

    cvCvtColor( src, dst, CV_GRAY2BGR );

    CvSeq *contour;   

    int contour_header_size = sizeof(CvContour);   
    CvMemStorage* contour_storage = cvCreateMemStorage (1000);

    int number_of_c=cvFindContours (src , contour_storage, &contour, 
      contour_header_size, CV_RETR_CCOMP, CV_CHAIN_APPROX_NONE); 

    std::cout<<"number of contours: "<<number_of_c <<"\n";
    int accum_count = 0;
    while(contour!=NULL)
    {
      cvDrawContours(dst, contour, CV_RGB(0, 255, 0), CV_RGB(255, 0, 0), 0, -1, 8);
      contour = contour->h_next;   
    }
    cvSaveImage( argv[2], dst );
  }
}
