/******************************************************************************
*
*   This file is part of the software tool "Cervix Image Processing 2 (CIP2)".
*
*   Author: Christoph Bergmeir
*   Supervisor: José M. Benítez
*   Copyright (c) DiCITS Lab, Sci2s group, DECSAI, University of Granada.
*
*   This program is free software; you can redistribute it and/or
*   modify it under the terms of the GNU General Public License
*   as published by the Free Software Foundation; either version 2
*   of the License, or (at your option) any later version.
*   
*   This program is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*   
*   You should have received a copy of the GNU General Public License
*   along with this program; if not, write to the Free Software
*   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
*   MA  02110-1301, USA.
*
******************************************************************************/

#include <string>
#include <iostream>

#include <cv.h>
#include <highgui.h>

int main( int argc, const char * argv[] )
{
  IplImage* img,*pimg;

  img=cvLoadImage( argv[1], CV_LOAD_IMAGE_UNCHANGED );

  pimg = cvCreateImage( cvGetSize(img), 8, 3 );

  cvCvtColor( img, pimg, CV_BGR2HSV );

  cvSaveImage( argv[2], pimg );

  if(img) cvReleaseImage(&img);
  if(pimg) cvReleaseImage(&pimg);

  return 0;
}
