/******************************************************************************
*
*   This file is part of the software tool "Cervix Image Processing 2 (CIP2)".
*
*   Author: Christoph Bergmeir
*   Supervisor: José M. Benítez
*   Copyright (c) DiCITS Lab, Sci2s group, DECSAI, University of Granada.
*
*   This program is free software; you can redistribute it and/or
*   modify it under the terms of the GNU General Public License
*   as published by the Free Software Foundation; either version 2
*   of the License, or (at your option) any later version.
*   
*   This program is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*   
*   You should have received a copy of the GNU General Public License
*   along with this program; if not, write to the Free Software
*   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
*   MA  02110-1301, USA.
*
******************************************************************************/

#include <cv.h>
#include <highgui.h>

#include <string>

int main( int argc, char * argv[] )
{
  IplImage *img, *img_r, *img_g, *img_b, *pimg, *pimg_r, *pimg_g, *pimg_b;

  img=cvLoadImage( argv[1], CV_LOAD_IMAGE_UNCHANGED );

  img_r = cvCreateImage( cvGetSize(img), IPL_DEPTH_8U, 1 );
  img_g = cvCreateImage( cvGetSize(img), IPL_DEPTH_8U, 1 );
  img_b = cvCreateImage( cvGetSize(img), IPL_DEPTH_8U, 1 );

  pimg_r = cvCreateImage( cvGetSize(img), IPL_DEPTH_8U, 1 );
  pimg_g = cvCreateImage( cvGetSize(img), IPL_DEPTH_8U, 1 );
  pimg_b = cvCreateImage( cvGetSize(img), IPL_DEPTH_8U, 1 );
  
  pimg = cvCreateImage( cvGetSize(img), IPL_DEPTH_8U, 3 );

  cvSplit( img,img_r,img_g,img_b,0);

  double threshold = atof(argv[3]);
  int type = CV_THRESH_BINARY;//CV_THRESH_TOZERO_INV;//CV_THRESH_TOZERO;//CV_THRESH_BINARY;

  cvThreshold( img_r, img_r, threshold, 255, type );
  cvThreshold( img_g, img_g, threshold, 255, type );
  cvThreshold( img_b, img_b, threshold, 255, type );

  cvMerge( img_r, img_g, img_b, NULL, pimg);
  //cvEqualizeHist( img_r, pimg_r );
  //cvEqualizeHist( img_g, pimg_g );
  //cvEqualizeHist( img_b, pimg_b );
  //cvMerge( pimg_r, pimg_g, pimg_b, NULL, pimg);

  std::string filename(argv[2]);
  /*std::string filename_red = filename + ".ch1.jpg";
  std::string filename_green = filename + ".ch2.jpg";
  std::string filename_blue = filename + ".ch3.jpg";
  std::string filename_grayscale = filename + ".gs.jpg";

  cvSaveImage( filename_red.c_str(), img_r );
  cvSaveImage( filename_green.c_str(), img_g );
  cvSaveImage( filename_blue.c_str(), img_b );*/
  cvSaveImage( filename.c_str(), pimg );

  if(img)
    cvReleaseImage(&img);
  if(img_r)
    cvReleaseImage(&img_r);
  if(img_g)
    cvReleaseImage(&img_g);   
  if(img_b)
    cvReleaseImage(&img_b);
  if(pimg)
    cvReleaseImage(&pimg);
  if(pimg_r)
    cvReleaseImage(&pimg_r);
  if(pimg_g)
    cvReleaseImage(&pimg_g);   
  if(pimg_b)
    cvReleaseImage(&pimg_b);

}

