/******************************************************************************
*
*   This file is part of the software tool "Cervix Image Processing 2 (CIP2)".
*
*   Author: Christoph Bergmeir
*   Supervisor: José M. Benítez
*   Copyright (c) DiCITS Lab, Sci2s group, DECSAI, University of Granada.
*
*   This program is free software; you can redistribute it and/or
*   modify it under the terms of the GNU General Public License
*   as published by the Free Software Foundation; either version 2
*   of the License, or (at your option) any later version.
*   
*   This program is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*   
*   You should have received a copy of the GNU General Public License
*   along with this program; if not, write to the Free Software
*   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
*   MA  02110-1301, USA.
*
******************************************************************************/

//#include <string>
//#include <iostream>

#include <cv.h>
#include <highgui.h>
#include <math.h>

int main(int argc, char** argv)
{
    IplImage* src;
    if((src=cvLoadImage(argv[1], 0))!= 0)
    {
        IplImage* dst;// = cvCreateImage( cvGetSize(src), 8, 1 );
        IplImage* color_dst = cvCreateImage( cvGetSize(src), 8, 3 );
        CvMemStorage* storage = cvCreateMemStorage(0);
        CvSeq* lines = 0;
        int i;
        //cvCanny( src, dst, 50, 200, 3 );
        dst=src;
        cvCvtColor( dst, color_dst, CV_GRAY2BGR );
//#if 1
        double rho = atof( argv[3] );
        double theta = atof( argv[4] );
        int threshold = atoi( argv[5] );

        lines = cvHoughLines2( dst, storage, CV_HOUGH_STANDARD, rho, theta*CV_PI/180, threshold, 0, 0 );

        for( i = 0; i < MIN(lines->total,100); i++ )
        {
            float* line = (float*)cvGetSeqElem(lines,i);
            float rho = line[0];
            float theta = line[1];
            CvPoint pt1, pt2;
            double a = cos(theta), b = sin(theta);
            double x0 = a*rho, y0 = b*rho;
            pt1.x = cvRound(x0 + 1000*(-b));
            pt1.y = cvRound(y0 + 1000*(a));
            pt2.x = cvRound(x0 - 1000*(-b));
            pt2.y = cvRound(y0 - 1000*(a));
            cvLine( color_dst, pt1, pt2, CV_RGB(255,0,0), 3, 8 );
        }
//#else
//        lines = cvHoughLines2( dst, storage, CV_HOUGH_PROBABILISTIC, 1, CV_PI/180, 50, 50, 10 );
//        for( i = 0; i < lines->total; i++ )
//        {
//            CvPoint* line = (CvPoint*)cvGetSeqElem(lines,i);
//            cvLine( color_dst, line[0], line[1], CV_RGB(255,0,0), 3, 8 );
//        }
//#endif
        //cvNamedWindow( "Source", 1 );
        //cvShowImage( "Source", src );

        //cvNamedWindow( "Hough", 1 );
        //cvShowImage( "Hough", color_dst );

  cvSaveImage( argv[2], color_dst );

  if(src) cvReleaseImage(&src);
  if(color_dst) cvReleaseImage(&color_dst);

        //cvWaitKey(0);
    }
}
