/******************************************************************************
*
*   This file is part of the software tool "Cervix Image Processing 2 (CIP2)".
*
*   Author: Christoph Bergmeir
*   Supervisor: José M. Benítez
*   Copyright (c) DiCITS Lab, Sci2s group, DECSAI, University of Granada.
*
*   This program is free software; you can redistribute it and/or
*   modify it under the terms of the GNU General Public License
*   as published by the Free Software Foundation; either version 2
*   of the License, or (at your option) any later version.
*   
*   This program is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*   
*   You should have received a copy of the GNU General Public License
*   along with this program; if not, write to the Free Software
*   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
*   MA  02110-1301, USA.
*
******************************************************************************/

#include <cv.h>
#include <highgui.h>

#include <string>
#include <iostream>

int main( int argc, char * argv[] )
{
  IplImage *img, *fimg, *img_gs, *fimg_gs, *pimg, *img_add, *fimg_gs_not;

  int invert_result = atoi(argv[4]);

  img=cvLoadImage( argv[1], CV_LOAD_IMAGE_UNCHANGED );
  fimg=cvLoadImage( argv[2], CV_LOAD_IMAGE_UNCHANGED );

  std::cout << "channels: " << img->nChannels << "\n";
  if(img->nChannels==3)
  {
    //img_gs = cvCreateImage( cvGetSize(img), IPL_DEPTH_8U, 1 );
    //cvCvtColor( img, img_gs, CV_BGR2GRAY );

    unsigned char *image_data= reinterpret_cast<unsigned char *>(img->imageData);

    std::cout << "img->width: " << img->width << "\n";
    std::cout << "img->height: " << img->height << "\n";
    std::cout << "img->widthStep: " << img->widthStep << "\n";

    unsigned char *fimage_data= reinterpret_cast<unsigned char *>(fimg->imageData);

    std::cout << "fimg->width: " << fimg->width << "\n";
    std::cout << "fimg->height: " << fimg->height << "\n";
    std::cout << "fimg->widthStep: " << fimg->widthStep << "\n";

    //int num_all_points = 0;
    for (int i=0; i<fimg->height; i++) {
      for (int j=0; j<fimg->width; j++) {
        if(fimage_data[i*fimg->widthStep + j]>0)
        {
        //  num_all_points++;
          //std::cout << "[j,i]: " << j << " " << i << "\n";
          int col[3] = {0,0,0};

          if(invert_result == 1)
          {
            col[0] = col[1] = col[2] = 255;
          }
          else if(invert_result == 2)
          {
            col[0] = 255;
          }
          else if(invert_result == 3)
          {
            col[1] = 255;
          }
          else if(invert_result == 4)
          {
            col[2] = 255;
          }

          image_data[i*img->widthStep + j*img->nChannels] = col[0];
          image_data[i*img->widthStep + j*img->nChannels + 1] = col[1];
          image_data[i*img->widthStep + j*img->nChannels + 2] = col[2];

        }
        //else std::cout << "missing: ";

      }
      //image_data+= stepsize;
    }
  std::string filename(argv[3]);
  cvSaveImage( filename.c_str(), img );
    return 0;

  }
  else if(img->nChannels==1)
    img_gs = img;

  std::cout << "channels: " << fimg->nChannels << "\n";

  //if(fimg->nChannels==3)
  //{
  //  fimg_gs = cvCreateImage( cvGetSize(img), IPL_DEPTH_8U, 1 );
  //  cvCvtColor( fimg, fimg_gs, CV_BGR2GRAY );
  //}
  //else if(fimg->nChannels==1)
    fimg_gs = fimg;

  img_add = cvCreateImage( cvGetSize(fimg), IPL_DEPTH_8U, 1 );
  fimg_gs_not = cvCreateImage( cvGetSize(fimg), IPL_DEPTH_8U, 1 );

  if(invert_result) cvNot( fimg_gs, fimg_gs_not );
  else fimg_gs_not =fimg_gs;

  cvAdd( img_gs, fimg_gs_not, img_add );

  pimg = cvCreateImage( cvGetSize(img), IPL_DEPTH_8U, 3 );

  cvMerge( img_gs, img_gs, img_add, NULL, pimg);

  std::string filename(argv[3]);
  cvSaveImage( filename.c_str(), pimg );

  if(img)
    cvReleaseImage(&img);
  if(fimg)
    cvReleaseImage(&fimg);
  //if(img_gs != NULL)
  //  cvReleaseImage(&img_gs);   
  //if(fimg_gs != NULL)
  //  cvReleaseImage(&fimg_gs);
  //if(fimg_gs_not != NULL)
  //  cvReleaseImage(&fimg_gs_not);
  if(img_add)
    cvReleaseImage(&img_add);
  if(pimg)
    cvReleaseImage(&pimg);

}

