//-------------------
//Auxiliary functions
//-------------------
function convertGPointtoSpecimenPoint(point)
{
	//128*2^maxZoomLevel--> this originates from the image embed in the tile inserter
	var offsetX = 65536-(specimenSizeX/2);
	var offsetY = 65536-(specimenSizeY/2);

	return new GPoint(point.x - offsetX, point.y - offsetY);
}

function convertSpecimenPointtoGPoint(point)
{
	var offsetX = 65536-(specimenSizeX/2);
	var offsetY = 65536-(specimenSizeY/2);

	return new GPoint(point.x + offsetX, point.y + offsetY);
}

//function myTileLayer(GCopyrightCollection) {
//    this.tilesPath = "tiles_processed";
//    this.getTileUrl = getProcessedTileURL;
//}

//myTileLayer.inherits(GTileLayer);

//var myTileLayer.tilesPath = "tiles";

//myTileLayer.method('getProcessedTileURL', function (a,b) {
//	return baseImageUrl + this.tilesPath + "/tile_" + b + "_"+ a.x + "_" + a.y + ".jpg";
//});

//-----------------------------------------------------
//Functions to get the different tile image file names
//-----------------------------------------------------
function getTestTileURL(a,b) 
{
	return baseImageUrl+"tiles_test/tile_" + b + "_"+ a.x + "_" + a.y + ".jpg";
}

function getOrigTileURL(a,b) 
{
	return baseImageUrl+"tiles/tile_" + b + "_"+ a.x + "_" + a.y + ".jpg";
}

function getFilterTileURL(a,b) 
{
	//GLog.write(baseImageUrl + "work_collections/"+ this.tilesPath + "tiles/tile_" + b + "_"+ a.x + "_" + a.y + ".jpg");
	return baseImageUrl + "work_collections/"+ this.tilesPath + "tiles/tile_" + b + "_"+ a.x + "_" + a.y + ".jpg";
}

//------------------------------------
//Functions to start the computations
//------------------------------------
function computeRegions()
{
	roiFindingParam1 = document.getElementById('param1').value;
	roiFindingParam2 = document.getElementById('param2').value;	
	//roi_finding_param3 = document.getElementById('param3').value;
	//roi_finding_param4 = document.getElementById('param4').value;	

	GLog.write('computing regions. params: ' + roiFindingParam1 + ' : ' + roiFindingParam2);
	var result = GDownloadUrl('phpsql_compute_regions.php?id_specimen=' + idSpecimen + '&param1=' + roiFindingParam1 + '&param2=' + roiFindingParam2
			 + '&param3=' + roiFindingParam3 + '&param4=' + roiFindingParam4, 
			function (data,response) {
		      window.location.reload();
		      //GLog.write(data);
		    });
	//window.open('phpsql_computeregions.php?id_muestra=' + id_muestra + '&param1=' + roi_finding_param1 + '&param2=' + roi_finding_param2);
	GLog.write('phpsql_compute_regions.php?id_specimen=' + idSpecimen + '&param1=' + roiFindingParam1 + '&param2=' + roiFindingParam2
			 + '&param3=' + roiFindingParam3 + '&param4=' + roiFindingParam4);
	//GLog.write(result);
}

function findNuclei()
{
	var manual = 0;
	var auto = 0;
	var confirmed = 0;
	
	if(document.getElementById('autogencheckbox').checked) auto = 1;
	if(document.getElementById('confirmedcheckbox').checked) confirmed = 1;
	if(document.getElementById('manualcheckbox').checked) manual = 1;
	
	//window.open('phpsql_find_nuclei_in_rois.php?id_specimen=' + idSpecimen);
	location.href="gui_find_nuclei_in_rois.php?id_specimen=" + idSpecimen + "&manual=" + manual + "&auto=" + auto + "&confirmed=" + confirmed;
}

function importCollection()
{
	//var path='';

	location.href="gui_import_collection.php?id_specimen=" + idSpecimen;
}

//------------------------------
//Region manipulation functions
//------------------------------
function addRegion(lat, lng, state) 
{
	
	var point = convertGPointtoSpecimenPoint(projection.fromLatLngToPixel(new GLatLng(lat, lng),maxZoomLevel));
	
    var size_x = 1920;
    var size_y = 1920;
	
	GLog.write('point.x: ' + point.x + '  point.y: ' + point.y);
	
    var url = "phpsql_add_region.php?id_specimen=" + idSpecimen +  "&state=" + state + "&x=" + point.x + "&y=" + point.y + "&size_x=" + size_x + "&size_y=" + size_y + "&lat=" + lat + "&lng=" + lng;
    GLog.write(url);
//    GDownloadUrl(url);
    
    GDownloadUrl(url, function(data, responseCode) {
      // To ensure against HTTP errors that result in null or bad data,
      // always check status code is equal to 200 before processing the data
      if(responseCode == 200) 
      {
    	  GLog.write("Received data: " + data);
    	  var parameters = data.split(" ");
    	  
    	  GLog.write("Parameters: " + parameters[2] + " : " + parameters[3] + " : " +  parameters[0]);
    	  
    	  var marker = createRegion(parseInt(parameters[3]), parseInt(parameters[4]), parseInt(parameters[0]), parseInt(parameters[2]), false); 
    	  map.addOverlay(marker);
      } 
      else if(responseCode == -1) 
      {
    	  GLog.write("addMarker: Data request timed out. Please try later.");
      } 
      else 
      { 
    	  GLog.write("addMarker: Request resulted in error...");
      }
    });
    
}

function removeRegion(id)
{
	
  GLog.write('removing the region..');
  GDownloadUrl('phpsql_remove_region.php?id=' + id);
  
  var index = autogenMarkers.indexOf(currentMarker);
  if (index >= 0) autogenMarkers.splice(index, 1);
  
  index = confirmedMarkers.indexOf(currentMarker);
  if (index >= 0) confirmedMarkers.splice(index, 1);

  index = manualMarkers.indexOf(currentMarker);
  if (index >= 0) manualMarkers.splice(index, 1);
  
  currentMarker.remove();
}

function confirmRegion(id)
{
  var index = autogenMarkers.indexOf(currentMarker);
  GLog.write(index);
  if (index >= 0) autogenMarkers.splice(index, 1);

  GLog.write('confirming the region..');
  GDownloadUrl('phpsql_confirm_region.php?id=' + id);

//  var blueIcon = new GIcon(G_DEFAULT_ICON);
//  blueIcon.image = "images/markerBlue.png";
//  currentMarker.setIcon(blueIcon);

  var id = currentMarker.myId;
  var lat = currentMarker.getLatLng().lat();
  var lng = currentMarker.getLatLng().lng();

  GLog.write('id: ' + id);
  currentMarker.remove();
  
  currentMarker = createRegion(lat, lng, id, enum_regionConfirmed, true); 
	
  
  //currentMarker.setImage("images/markerBlue.png");  
  confirmedMarkers.push(currentMarker);
  map.addOverlay(currentMarker);
  //currentMarker = marker;
//
//index = confirmedMarkers.indexOf(currentMarker);
//if (index >= 0) confirmedMarkers.splice(index);
//
//index = manualMarkers.indexOf(currentMarker);
//if (index >= 0) manualMarkers.splice(index);
  
}

//projection , map have to be set. currentMarker is modified
function createRegion(x, y, id, state, isLL) 
{

  //if the region is disabled, don't do nothing with it..
  if(state == enum_regionDeleted) return;
	
  if(isLL)
	var regionLatLng = new GLatLng(x, y);
  else
  {
	var point = convertSpecimenPointtoGPoint(new GPoint(x, y));
	//GLog.write('point.x: ' + point.x + '  point.y: ' + point.y);
	var regionLatLng = projection.fromPixelToLatLng(point,maxZoomLevel);
	//GLog.write('regionLatLng.lat(): ' + regionLatLng.lat() + '  regionLatLng.lng(): ' + regionLatLng.lng());
  }
	
  if(state == enum_regionConfirmed)
  {
	var blueIcon = new GIcon(G_DEFAULT_ICON);
	blueIcon.image = "images/markerBlue.png";
	markerOptions = { icon:blueIcon };
  }
  else if(state == enum_regionManualNoZoomIn)
  {
		var yellowIcon = new GIcon(G_DEFAULT_ICON);
		yellowIcon.image = "images/markerYellow.png";
		markerOptions = { icon:yellowIcon };
  }
  else if(state == enum_regionManualZoomIn)
  {
		var greenIcon = new GIcon(G_DEFAULT_ICON);
		greenIcon.image = "images/markerGreen.png";
		markerOptions = { icon:greenIcon };
  }
  else  markerOptions = {};
  
    var marker = new GMarker(regionLatLng, markerOptions);
    
    marker.myId = id;
 
  if(state == enum_regionConfirmed || state == enum_regionManualNoZoomIn || state == enum_regionManualZoomIn)
  {
	    GEvent.addListener(marker, "click", function() {

	    	var point = projection.fromLatLngToPixel(marker.getLatLng(),maxZoomLevel);
	    	GLog.write('point.x: ' + point.x + '  point.y: ' + point.y);
	   		
	    	var message='<a href="javascript:removeRegion(' + id + ')">Remove this region</a><br/>';

	    	currentMarker = marker;
	    	
	        marker.openInfoWindowHtml(message);
	    });
	    
	    if(state == enum_regionConfirmed) confirmedMarkers.push(marker);
        else if (state == enum_regionManualZoomIn || state == enum_regionManualNoZoomIn) manualMarkers.push(marker);

	    //map.addOverlay(marker);
  }
  else
  {
    GEvent.addListener(marker, "click", function() {

    	var point = projection.fromLatLngToPixel(marker.getLatLng(),maxZoomLevel);
    	GLog.write('point.x: ' + point.x + '  point.y: ' + point.y);
   		
    	var message='<a href="javascript:removeRegion(' + id + ')">Remove this region</a><br/>' + 
    				'<a href="javascript:confirmRegion(' + id + ')">Confirm this region</a><br/>';

    	currentMarker = marker;
    	
        marker.openInfoWindowHtml(message);
    }); 
    
    autogenMarkers.push(marker);
  };
  
  	 
	  
    //drawCircleMercator(marker.getLatLng().lat(), marker.getLatLng().lng(), 100.0, "#000080", 1, 0.75, "#0000FF",.5);
    //drawRectangleEuclidean(marker.getLatLng().lat(), marker.getLatLng().lng(), 100.0, "#000080", 1, 0.75, "#0000FF",.5);
  
    
    
    return marker;
  }
