
var maxZoomLevel = 9;

var map;
var projection;

var currentMarker;

var manualMarkers = new Array();
var autogenMarkers = new Array();
var confirmedMarkers = new Array();

var filterLayerControl;
var filterLayers = [];

//the enum for the regions. This has to be the same as in configure.php
var enum_regionDeleted = -1;
var enum_regionAutomatic = 0;
var enum_regionConfirmed = 1;
var enum_regionManualNoZoomIn = 2;
var enum_regionManualZoomIn = 3;

//the default view upon opening
var centerLat = 0, centerLong = 0, initialZoom = 2;

window.onresize = handleResize;
window.onload = init;
window.onunload = GUnload;

var showToogleText = Array (false, false, false);

function handleResize() {
	//var height = windowHeight() - document.getElementById('toolbar').offsetHeight - 45;
	var height = windowHeight() - 170;
	document.getElementById('map').style.height = height + 'px';
}

function toogleText(x) 
{ 
	if (showToogleText[x])
	{
		document.getElementById('toogletext' + x).style.display = 'none';
		showToogleText[x] = false;
	}
	else
	{
		document.getElementById('toogletext' + x).style.display = 'block';
		showToogleText[x] = true;
	}
} 

function autogenCheckboxToggled()
{
	if(document.getElementById('autogencheckbox').checked)
	    for(i=0;i<autogenMarkers.length;i++) map.addOverlay(autogenMarkers[i]);
	else
	    for(i=0;i<autogenMarkers.length;i++) autogenMarkers[i].remove();
}

function confirmedCheckboxToggled()
{
	if(document.getElementById('confirmedcheckbox').checked)
	    for(i=0;i<confirmedMarkers.length;i++) map.addOverlay(confirmedMarkers[i]);
	else
	    for(i=0;i<confirmedMarkers.length;i++) confirmedMarkers[i].remove();
}

function manualCheckboxToggled()
{
	if(document.getElementById('manualcheckbox').checked)
	    for(i=0;i<manualMarkers.length;i++) map.addOverlay(manualMarkers[i]);
	else
	    for(i=0;i<manualMarkers.length;i++) manualMarkers[i].remove();
}

var callbackLatLng;
var globalEvent;

function callbackAddRegion() {
  latlng = callbackLatLng;
  if (globalEvent.shiftKey) {
   if (latlng) { addRegion(latlng.lat(), latlng.lng(), enum_regionManualZoomIn); };
  }
  else {
   if (latlng) { addRegion(latlng.lat(), latlng.lng(), enum_regionManualNoZoomIn); };			
  };
}

function init() {
	
	if(document.getElementById('param1'))
	{
  	  document.getElementById('param1').value = roiFindingParam1;		  	
	  document.getElementById('param2').value = roiFindingParam2;	
	}
	
	handleResize();
	geocoder = new GClientGeocoder();

	//The copyright for the slide images
	var copyright = new GCopyright(1,
						  new GLatLngBounds(new GLatLng(-90, -180),
											new GLatLng(90, 180)),
						  0,
						  "Copyright 2009, Universidad de Granada");
	
	var copyrightCollection = new GCopyrightCollection("");
	copyrightCollection.addCopyright(copyright);
	
	//projection = new GMercatorProjection(18);
	projection = new EuclideanProjection(18);	
	
	
	//create custom picture layers
	//MT var tileLayerTest = [ new GTileLayer(copyrightCollection , 1, 17)];
	//MT tileLayerTest[0].getTileUrl = getTestTileURL;
	
	var tileLayerOrig = [ new GTileLayer(copyrightCollection , 1, 17)];
	tileLayerOrig[0].getTileUrl = getOrigTileURL;

	//MT var testMapType = new GMapType(tileLayerTest, projection, "Test",{maxResolution:maxZoomLevel-1, minResolution:2, errorMessage:"", radius: 1E-3});
	var originalMapType = new GMapType(tileLayerOrig, projection, "Original",{maxResolution:maxZoomLevel-1, minResolution:2, errorMessage:"", radius: 1E-3});

	//Now create the custom map.
	//MT map = new GMap2(document.getElementById("map"),{mapTypes:[originalMapType, testMapType]});
	map = new GMap2(document.getElementById("map"),{mapTypes:[originalMapType]});
	var pos = new GControlPosition(G_ANCHOR_TOP_LEFT, new GSize(18,50));

	map.addControl(new GLargeMapControl(), pos);
	//MT map.addControl(new GMapTypeControl());	
	
	//Default to a black background just in case tiles are missing
	document.getElementById('map').style.backgroundColor = 'black';
	document.getElementById('content').style.paddingTop = '0';
	document.getElementById('content').style.backgroundColor = 'black';
	
	//Add the overview map control
	var ovMapType = new GMapType(tileLayerOrig, projection, "Overview Map",{maxResolution:0, minResolution:0, errorMessage:"", radius: 1E-3});
	
	ovMapType.getMinimumResolution = function() {return 1;};
	ovMapType.getMaximumResolution = function() {return 1;};
    
    var ovControl = new GOverviewMapControl(new GSize(300,300));	
    ovControl.setMapType(ovMapType);
    map.addControl(ovControl); 

    GEvent.addDomListener(document.getElementById("map"), "click", function(e) { globalEvent = e; });
    
	GEvent.addListener(map, "click", function(overlay,latlng) {
            callbackLatLng = latlng;
            if(!window.event)
              setTimeout("callbackAddRegion()",500);
            else 
             {
              globalEvent = window.event;
              callbackAddRegion();
             }

	  });



//	GEvent.addListener(map, "singlerightclick", function(latlng, not_used1, not_used2) {
//	    if (latlng) {
//	  	  addRegion(latlng.lat(), latlng.lng(), enum_regionConfirmed);
//	    }
//	  });
	
	//Set interaction parameters for the large main map
	map.enableDoubleClickZoom();
	map.enableContinuousZoom();
	map.enableScrollWheelZoom(); 
	map.setCenter(new GLatLng(centerLat, centerLong), initialZoom, originalMapType);
	map.setZoom(parseInt(initialZoom));

	
    for(i=0;i<filterResultsName.length;i++) 
    { 
   	  var tileLayer = new GTileLayer(new GCopyrightCollection(), 1, 17);
   	  
   	  tileLayer.tilesPath = workCollectionPaths[filterResultsWorkCollection[i]] + "filter_results/" + filterResultsPath[i];
   	  //$pathWorkCollection."filter_results/".$row2["path"];
	  //tileLayer.tilesPath = filterResultsPath[i];
	  tileLayer.getTileUrl = getFilterTileURL;
	  tileLayer.getOpacity = function() {return 1.0;}
	  
	  filterLayers[i] = new GTileLayerOverlay(tileLayer);
	  filterLayers[i].Visible = false;
	  filterLayers[i].Added = false;
	  filterLayers[i].workCollection = filterResultsWorkCollection[i];
    }
    
    filterLayerControl = new LayerControl(filterResultsName);
    
	//------------------------------------
//	 var tileLayerProcessed = new GTileLayer(new GCopyrightCollection(), 1, 17);
//	 tileLayerProcessed.tilesPath = "tiles_processed";
//	 tileLayerProcessed.getTileUrl = getProcessedTileURL;
//	 tileLayerProcessed.getOpacity = function() {return 1.0;} //return 0.5;
//	 
//	 filterLayers[0] = new GTileLayerOverlay(tileLayerProcessed);
//	 filterLayers[0].Visible = false;
//	 filterLayers[0].Added = false;
//	    
//	 filterLayerControl = new LayerControl(["FilterTest"]);
	   
	 map.addControl(new MoreControl());
	 
//	 map.addOverlay(new GTileLayerOverlay(tileLayerProcessed));
	 //-----------------------------

//--------------------------------------------------
//Add layer control
//---------------------------------------------------
	
//    var layers = [];      

    
//    layers[1] = new GLayer("org.wikipedia.de");
//    layers[1].Visible = false;
//    layers[1].Added = false;
//    
//    layers[2] = new GLayer("com.panoramio.all");
//    layers[2].Visible = false;
//    layers[2].Added = false;
//
//    layers[3] = new GLayer("com.panoramio.popular");
//    map.addOverlay(layers[3]);  // This one open by default
//    layers[3].Visible = true;
//    layers[3].Added = true;

// === Create the layerControl, but don't addControl() it ===
// = Pass it an array of names for the checkboxes =
//var layerControl = new LayerControl(["Wiki", "Wike DE", "Photos", "Popular"]);
    

// === Create the MoreControl(), and do addControl() it ===
    
//-------------------------------------------------------------



//	var center = createMarker(0, 0, 0, false);
//	map.addOverlay(center);
	
	//setTimeout("map.setZoom(parseInt(initialZoom));",1);
	
    for(i=0;i<regionsX.length;i++) 
    {    	
      createRegion(regionsX[i], regionsY[i], regionsId[i], regionsState[i], false);    	
      //GLog.write("Circle Position: " + markers_x[i] + " : " + markers_y[i]);
    };
  
	document.getElementById('autogencheckbox').checked = true;
	document.getElementById('confirmedcheckbox').checked = true;
	document.getElementById('manualcheckbox').checked = true;
	
	autogenCheckboxToggled();
	confirmedCheckboxToggled();
	manualCheckboxToggled();
	
}
