if (!Array.indexOf) {
  Array.prototype.indexOf = function (obj, start) {
    for (var i = (start || 0); i < this.length; i++) {
      if (this[i] == obj) {
        return i;
      }
    }
  }
}

      // ====== Create the Euclidean Projection for the flat map ======
      // == Constructor ==
      function EuclideanProjection(a){
        this.pixelsPerLonDegree=[];
        this.pixelsPerLonRadian=[];
        this.pixelOrigo=[];
        this.tileBounds=[];
        var b=256;
        var c=1;
        for(var d=0;d<a;d++){
          var e=b/2;
          this.pixelsPerLonDegree.push(b/360);
          this.pixelsPerLonRadian.push(b/(2*Math.PI));
          this.pixelOrigo.push(new GPoint(e,e));
          this.tileBounds.push(c);
          b*=2;
          c*=2
        }
      }
 
      // == Attach it to the GProjection() class ==
      EuclideanProjection.prototype=new GProjection();
 
 
      // == A method for converting latitudes and longitudes to pixel coordinates == 
      EuclideanProjection.prototype.fromLatLngToPixel=function(a,b){
        var c=Math.round(this.pixelOrigo[b].x+a.lng()*this.pixelsPerLonDegree[b]);
        var d=Math.round(this.pixelOrigo[b].y+(-2*a.lat())*this.pixelsPerLonDegree[b]);
        return new GPoint(c,d)
      };

      // == a method for converting pixel coordinates to latitudes and longitudes ==
      EuclideanProjection.prototype.fromPixelToLatLng=function(a,b,c){
        var d=(a.x-this.pixelOrigo[b].x)/this.pixelsPerLonDegree[b];
        var e=-0.5*(a.y-this.pixelOrigo[b].y)/this.pixelsPerLonDegree[b];
        return new GLatLng(e,d,c)
      };

      // == a method that checks if the y value is in range, and wraps the x value ==
      EuclideanProjection.prototype.tileCheckRange=function(a,b,c){
        var d=this.tileBounds[b];
        if (a.y<0||a.y>=d) {
          return false;
        }
        if(a.x<0||a.x>=d){
          a.x=a.x%d;
          if(a.x<0){
            a.x+=d;
          }
        }
        return true
      }

      // == a method that returns the width of the tilespace ==      
      EuclideanProjection.prototype.getWrapWidth=function(zoom) {
        return this.tileBounds[zoom]*256;
      }
//------------------------------------------

   // ==== The "More..." control simply accepts a mouseover to reveal the "Layer" control ===

      function MoreControl() {}
      MoreControl.prototype = new GControl();

      var filterMenuIsVisible = false;
      
      MoreControl.prototype.initialize = function(map) {
        var container = document.createElement("div");
        container.style.border = "2px solid black";
        container.style.fontSize = "12px";
        container.style.fontFamily = "Arial, sans-serif";
        container.style.width="120px";
        container.style.backgroundColor = "#ffffff";
        container.style.textAlign = "center";
        container.innerHTML = "Filter results...";
                
        map.getContainer().appendChild(container);
        
//        GEvent.addDomListener(container, "mouseover", function() {
//          map.addControl(filterLayerControl);
//        });

        GEvent.addDomListener(container, "click", function() {
        	
            GLog.write('Control clicked: ' + filterMenuIsVisible);
        	if(filterMenuIsVisible)
        	{
        		map.removeControl(filterLayerControl);
        		filterMenuIsVisible = false;
        	}
        	else
        	{
                map.addControl(filterLayerControl);
                filterMenuIsVisible = true;
        	};
          });
        
//        GEvent.addDomListener(container, "mouseout", function() {
//            map.removeControl(layerControl);
//          });
        
        return container;
      }
      
      MoreControl.prototype.getDefaultPosition = function() {
        //return new GControlPosition(G_ANCHOR_TOP_RIGHT, new GSize(210, 7));
        return new GControlPosition(G_ANCHOR_TOP_RIGHT, new GSize(7, 7));
      }


      
      // ==== The "Layer" control displays the "More..." plus the checkboxes ====
      // ==== The checkbox info is passed in the "opts" parameter ====

      function LayerControl(opts) {
        this.opts = opts;
      }
      LayerControl.prototype = new GControl();

      LayerControl.prototype.initialize = function(map) 
      {
        var container = document.createElement("div");
        
        container.style.border = "2px solid black";
        container.style.fontSize = "12px";
        container.style.fontFamily = "Arial, sans-serif";
        container.style.width="200px";
        container.style.backgroundColor = "#ffffff";
        container.innerHTML = "";
        //container.innerHTML = '<center><b>Filter results...<\/b><\/center>';
        
        var lastWorkCollection = -1;
        
        for (var i=0; i<this.opts.length; i++) 
        {
        	//GLog.write("ID: " + i + " : " + lastWorkCollection + " : " + filterLayers[i].workCollection);
          if (filterLayers[i].Visible) 
          {
            var c = 'checked';
          } 
          else 
          {
            var c = '';
          }
          
          if(filterLayers[i].workCollection != lastWorkCollection)
          {
        	  container.innerHTML += workCollectionNames[filterLayers[i].workCollection] + ':<br>';
        	  lastWorkCollection = filterLayers[i].workCollection;
          }        
          
          container.innerHTML += '<input type="checkbox" onclick="toggleLayer('+i+')" ' +c+ ' /> '+this.opts[i]+'<br>';
          //container.innerHTML += '<input type="checkbox" onclick="toggleLayer('+i+')" ' +c+ ' /> '+this.opts[i]+'<br>';
        }
          
      
        map.getContainer().appendChild(container);
        
        // === This doesn't do what I want. It kills the control if I mouseover a checkbox ===
        // === If you know how to do this better, let me know ===

//        GEvent.addDomListener(container, "click", function() {
//          map.removeControl(filterLayerControl);
//        });

        //setTimeout("map.removeControl(filterLayerControl)",5000);
        
        
        return container;
      }
      
      LayerControl.prototype.getDefaultPosition = function() {
        //return new GControlPosition(G_ANCHOR_TOP_RIGHT, new GSize(210, 7));
        return new GControlPosition(G_ANCHOR_TOP_RIGHT, new GSize(7, 28));
      }



      // ==== toggleLayer adds and removes the layers ====
      function toggleLayer(i) 
      {
        if (filterLayers[i].Visible) 
        {
          filterLayers[i].hide();
          map.removeOverlay(filterLayers[i]);
          filterLayers[i].Added = false;
        } 
        else 
        {
          if(filterLayers[i].Added) 
          {
        	filterLayers[i].show();
          } 
          else 
          {
            map.addOverlay(filterLayers[i]);
            filterLayers[i].Added = true;
            filterLayers[i].show();
          }
        }
        filterLayers[i].Visible = !filterLayers[i].Visible;
      }
      
//other
function windowHeight() {
  // Standard browsers (Mozilla, Safari, etc.)
  if (self.innerHeight) {
    return self.innerHeight;
  }
  // IE 6
  if (document.documentElement && document.documentElement.clientHeight) {
   return document.documentElement.clientHeight;
  }
  // IE 5
  if (document.body) {
    return document.body.clientHeight;
  }
  // Just in case. 
  return 0;
}

//map has to be set
function drawCircleMercator(lat, lng, radius, strokeColor, strokeWidth, strokeOpacity, fillColor, fillOpacity) 
{
  var d2r = Math.PI/180;
  var r2d = 180/Math.PI;
  var Clat = radius * 0.014483;  // Convert statute miles into degrees latitude
  var Clng = Clat/Math.cos(lat*d2r); 
  var Cpoints = []; 
  for (var i=0; i < 33; i++) 
  { 
    var theta = Math.PI * (i/16);
    Cy = lat + (Clat * Math.sin(theta));
    Cx = lng + (Clng * Math.cos(theta));
    var P = new GLatLng(Cy, Cx);
    Cpoints.push(P);
  }

  var polygon = new GPolygon(Cpoints, strokeColor, strokeWidth, strokeOpacity, fillColor, fillOpacity);
  map.addOverlay(polygon);
  //return polygon;
}

//map and projection have to be set
function drawRectangleEuclidean(lat, lng, radius, strokeColor, strokeWidth, strokeOpacity, fillColor, fillOpacity) 
{
	
	var Cpoints = [];
	var point = projection.fromLatLngToPixel(new GLatLng(lat, lng),maxZoomLevel);
	
	var	tl = new GPoint(point.x-960, point.y-960);
	var	tr = new GPoint(point.x+960, point.y-960);
	var	bl = new GPoint(point.x-960, point.y+960);
	var	br = new GPoint(point.x+960, point.y+960);
	
	Cpoints.push(projection.fromPixelToLatLng(bl,maxZoomLevel));
	Cpoints.push(projection.fromPixelToLatLng(br,maxZoomLevel));
	Cpoints.push(projection.fromPixelToLatLng(tr,maxZoomLevel));
	Cpoints.push(projection.fromPixelToLatLng(tl,maxZoomLevel));	

  var polygon = new GPolygon(Cpoints, strokeColor, strokeWidth, strokeOpacity, fillColor, fillOpacity);
  map.addOverlay(polygon);
}

