<?php

/******************************************************************************
*
*   This file is part of the software tool "Cervix Image Processing 2 (CIP2)".
*
*   Author: Christoph Bergmeir
*   Supervisor: José M. Benítez
*   Copyright (c) DiCITS Lab, Sci2s group, DECSAI, University of Granada.
*
*   This program is free software; you can redistribute it and/or
*   modify it under the terms of the GNU General Public License
*   as published by the Free Software Foundation; either version 2
*   of the License, or (at your option) any later version.
*   
*   This program is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*   
*   You should have received a copy of the GNU General Public License
*   along with this program; if not, write to the Free Software
*   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
*   MA  02110-1301, USA.
*
******************************************************************************/

require("configure.php");

function begins_with($string, $beginstr)
{
    return (strncmp($string, $beginstr, strlen($beginstr)) == 0);
}

function common_prefix($string, $beginstr)
{
	$i = 0;
	for(;$i<strlen($beginstr);$i++)
	 if($string[$i] != $beginstr[$i]) break;
    return $i;
}

function ends_with($string, $endstr)
{
    $string_end = substr($string, strlen($string) - strlen($endstr));
    return (strncmp($string_end, $endstr, strlen($endstr)) == 0);
}

//CSV  function csv_write($csv_array, $fp) 
//CSV  {
//CSV      $line="\"".implode("\",\"",$csv_array)."\"\r\n";
//CSV      fwrite($fp, $line);
//CSV  }

function bp_apply_filter_gen($path_data, $filter_executable, $filter_name, $filter_shortname, $no_parameters, $parameter_sets, $path_data2 = "", $fileEnd = ".png")
{

global $separator, $separatorNot;

if(!ends_with($path_data,"/")) die("Data Path has to end with /"); 

$dir_handle = @opendir($path_data) or die("Unable to open $path_data"); 

while ($file = readdir($dir_handle)) 
{
  if($file == "." || $file == "..") continue; 
  if(!ends_with($file,".jpg") && !ends_with($file,".png") && !ends_with($file,".BMP")) continue;
  $files[] = $file;
} 

closedir($dir_handle);

//var_dump($files);

//shell_exec(str_replace($separatorNot, $separator, "mkdir ".$path_thumbnails));
    
//die("finished so far..");
 


//$files = array("1-1.jpg", "1-2.jpg", "1-3.jpg", "10-2.jpg", "10-3.jpg", "12-1.jpg", "12-2.jpg", "12-3.jpg", "12-4.jpg", 
//"2-1.jpg", "2-2.jpg", "2-3.jpg", "2-4.jpg", "3-1.jpg", "3-2.jpg", "4-1.jpg", "4-2.jpg", "4-3.jpg", "4-4.jpg", 
//"5-2.jpg", "6-1.jpg", "6-2.jpg", "9-3.jpg", "9-4.jpg");

if($no_parameters) 
 {
  $num_parameters = 0; 
  $parameter_sets = array(array(0));
 }
else $num_parameters = sizeof($parameter_sets[0]);


/*CSV  

$csvfile = $path_results."comments_autogen.csv";

$csvheader1begin = array('Input File', 'Filter');
$csvheader2begin = array('Input File', 'Filter');

if($num_parameters>0) 
{
  $csvheader1begin[]= 'Parameters'; 
  $csvheader2begin[]= 'p0'; 
};

for($count = 1; $count < $num_parameters; $count++)
{
  $csvheader1begin[]= ''; 
  $csvheader2begin[]= 'p'.$count; 
}

$csvheader1end = array('Zoom (10/20/40/unknown)', 'Contents input file', '', '', '', 'Results of filtering', '', '', '', 
                       'Probably useful? (yes/maybe/probably not/no)');

$csvheader2end = array('Zoom (10/20/40/unknown)', 'How many cells (very few/few/many/very many)', 'Cells distinguishable(yes/mostly/partly/no)', 
                          'Colors(red/more red/more blue/blue/other)', 'Other observations', 
                          'Nuclei separated (good/mostly/partly/bad)', 'Cytoplasm separated(good/mostly/partly/bad)', 
                          'Background separated(good/mostly/partly/bad)', 'Other observations', 'Probably useful? (yes/maybe/probably not/no)');

$csvheader1 = array_merge($csvheader1begin, $csvheader1end);
$csvheader2 = array_merge($csvheader2begin, $csvheader2end);

$fp=fopen($csvfile,"w+");

csv_write($csvheader1, $fp);
csv_write($csvheader2, $fp);
*/

echo "\nApplying $filter_name...\n";

$path_data2_given = false;
if($path_data2 != "") $path_data2_given = true;

if($path_data2_given)
{
  if(!ends_with($path_data2,"/")) die("Data Path 2 has to end with /, if given"); 
  //$dir_handle = @opendir($path_data2) or die("Unable to open $path_data2"); 
}

foreach ($parameter_sets as $ps) 
{
  if($no_parameters) $str_ps = $filter_name; 
  else $str_ps = "$filter_name-".implode("-",$ps);
  
  $cmdl_ps = implode(" ",$ps);
  echo "Using Parameter Set: ".$str_ps."\n";
  
  if(count($parameter_sets) == 1)
    $path_results = $path_data.$filter_shortname.$separator;
  else 
    $path_results = $path_data.$filter_shortname."-".$str_ps.$separator;
    
  //echo "Results are put in: ".$path_results."\n";

  shell_exec(str_replace($separatorNot, $separator, "mkdir ".$path_results));
  shell_exec(str_replace($separatorNot, $separator, "mkdir ".$path_results."_".$str_ps.$separator));
      
  foreach ($files as $current_file)
  {
  	echo $current_file."\n";
  	
  	//-------------------------------------------
  	$current_file2 = "";
  	if($path_data2_given)
  	{
      //if(!ends_with($path_data2,"/")) die("Data Path 2 has to end with /, if given"); 

      $dir_handle = @opendir($path_data2) or die("Unable to open $path_data2"); 

      $max = 0;      
      while ($file = readdir($dir_handle)) 
      {

      	
      	//if(begins_with($current_file, $file))
      	$common = common_prefix($current_file, $file);
      	//echo "Common Prefix: $common\n";
      	if($common>$max)
      	{
      		$max = $common; 
      		$current_file2 = $file." ";
      		//break;
      	}
        //if($file == "." || $file == "..") continue; 
        //if(!ends_with($file,".jpg")) continue;
        //$files[] = $file;
      } 
  	
  	//$path_data2
  	}
  	//-------------------------------------------
  	
  	if(ends_with($current_file,$fileEnd))
  	  $filtered_file = "$current_file";
  	else 
  	  $filtered_file = "$current_file$fileEnd";
  	  
    //$filtered_file = "$current_file.$str_ps.png";
    
        
  	$commandline_filter = "$filter_executable $path_data2$current_file2$path_data$current_file $path_results$filtered_file $cmdl_ps";
  	echo $commandline_filter."\n";
  	$prog_output_filter = shell_exec($commandline_filter);
    echo $prog_output_filter;
      	
//CSV  	$str_csv = array_merge(array($current_file, $filter_name), $ps);
//CSV  	csv_write($str_csv, $fp);
  }
}

//CSV  fclose($fp);
}
?>
