<?php 

/******************************************************************************
*
*   This file is part of the software tool "Cervix Image Processing 2 (CIP2)".
*
*   Author: Christoph Bergmeir
*   Supervisor: José M. Benítez
*   Copyright (c) DiCITS Lab, Sci2s group, DECSAI, University of Granada.
*
*   This program is free software; you can redistribute it and/or
*   modify it under the terms of the GNU General Public License
*   as published by the Free Software Foundation; either version 2
*   of the License, or (at your option) any later version.
*   
*   This program is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*   
*   You should have received a copy of the GNU General Public License
*   along with this program; if not, write to the Free Software
*   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
*   MA  02110-1301, USA.
*
******************************************************************************/

require("bp_apply_filter.php");

$pathData = $argv[1];
$filterName = $argv[2];

if(!ends_with($pathData,"/")) die("Data Path has to end with /"); 

switch ($filterName) {
    case "Preprocessing":
    	
    	bp_apply_filter($pathData, "RGBGradientAnisotropicDiffusionImageFilter");
    	bp_apply_filter($pathData."RGBGradientAnisotropicDiffusionImageFilter/", "cvCvtColorBgr2Gray");
  	  	bp_apply_filter($pathData."RGBGradientAnisotropicDiffusionImageFilter/cvCvtColorBgr2Gray/", "GradientMagnitudeRecursiveGaussianImageFilter");
  	  	    	
    	bp_apply_filter($pathData, "cvCvtColorBgr2Gray");
  	  	bp_apply_filter($pathData."cvCvtColorBgr2Gray/", "GradientMagnitudeRecursiveGaussianImageFilter");
  	  	    	
    	bp_apply_filter($pathData."cvCvtColorBgr2Gray/", "CurvatureAnisotropicDiffusionImageFilter");
    	bp_apply_filter($pathData."cvCvtColorBgr2Gray/CurvatureAnisotropicDiffusionImageFilter/", "GradientMagnitudeRecursiveGaussianImageFilter");

    	break;

    	
    case "MaskGeneration":
    	//array(array(0, 30, 0, 255))
    	//bp_apply_filter($pathData, "GradientMagnitudeRecursiveGaussianImageFilter");    	
    	bp_apply_filter($pathData, "BinaryThresholdImageFilter");
    	    	
    	bp_apply_filter($pathData."BinaryThresholdImageFilter/", "cvErode");
        bp_apply_filter($pathData."BinaryThresholdImageFilter/cvErode/", "cvVisResultsRgb", true, array(array(0)), $pathData);                   	    	
        bp_apply_filter($pathData."BinaryThresholdImageFilter/cvErode/", "itkMaskImageFilter", true, array(array(0)), $pathData."GMRGIF/");    	
    	
    	bp_apply_filter($pathData."BinaryThresholdImageFilter/cvErode/", "cvDilate");
        bp_apply_filter($pathData."BinaryThresholdImageFilter/cvErode/cvDilate/", "cvVisResultsRgb", true, array(array(0)), $pathData);
        bp_apply_filter($pathData."BinaryThresholdImageFilter/cvErode/cvDilate/", "itkMaskImageFilter", true, array(array(0)), $pathData."GMRGIF/");
        
        //bp_apply_filter($pathData."BinaryThresholdImageFilter/cvErode/cvDilate/", "itkMaskImageFilter", true, array(array(0)), $pathData."GradientMagnitudeRecursiveGaussianImageFilter/");        
    	break;  
    case "PreProcMask":
     	bp_apply_filter($pathData, "cvPyrMeanShiftFiltering", true, array(array(20, 40, 2)));
    	bp_apply_filter($pathData, "cvCvtColorBgr2Gray");
    	     	
    	bp_apply_filter($pathData."cvPMS/", "cvCvtColorBgr2Gray");
    	bp_apply_filter($pathData."cvPMS/cvBgr2Gr/", "GradientMagnitudeRecursiveGaussianImageFilter");
    	bp_apply_filter($pathData."cvPMS/cvBgr2Gr/", "BinaryThresholdImageFilter", true, array(array(0, 211, 0, 255)));
    	bp_apply_filter($pathData."cvPMS/cvBgr2Gr/itkBth/", "cvErode", true, array(array(3)));    	    	
        bp_apply_filter($pathData."cvPMS/cvBgr2Gr/itkBth/cvEro/", "cvVisResultsRgb", true, array(array(0)), $pathData."cvBgr2Gr/");

      	bp_apply_filter($pathData."cvBgr2Gr/", "BinaryThresholdImageFilter", true, array(array(0, 146, 0, 255)));
    	bp_apply_filter($pathData."cvBgr2Gr/itkBth/", "cvDilate", true, array(array(3)));
        bp_apply_filter($pathData."cvBgr2Gr/itkBth/cvDil/", "cvVisResultsRgb", true, array(array(0)), $pathData."cvBgr2Gr/");

        //bp_apply_filter($pathData."cvPMS/cvBgr2Gr/itkBth/cvEro/", "itkMaskImageFilter", true, array(array(0)), $pathData."cvPMS/cvBgr2Gr/itkGMRG/");             
        //bp_apply_filter($pathData."cvBgr2Gr/itkBth/cvDil/", "itkMaskImageFilter", true, array(array(0)), $pathData."cvPMS/cvBgr2Gr/itkBth/cvEro/itkMask/");

        bp_apply_filter($pathData."cvPMS/cvBgr2Gr/itkBth/cvEro/", "itkMaskImageFilter", true, array(array(0)), $pathData."cvBgr2Gr/itkBth/cvDil/");             
        bp_apply_filter($pathData."cvPMS/cvBgr2Gr/itkBth/cvEro/itkMask/", "itkMaskImageFilter", true, array(array(0)), $pathData."cvPMS/cvBgr2Gr/itkGMRG/");    	
        shell_exec(str_replace($separatorNot, $separator, "move ".$pathData."cvPMS/cvBgr2Gr/itkBth/cvEro/itkMask/itkMask ".$pathData."cvPMS/cvBgr2Gr/itkBth/cvEro/itkMask/itkMask_PMS_GMRG"));
        
    	bp_apply_filter($pathData."cvPMS/cvBgr2Gr/itkBth/cvEro/itkMask/itkMask_PMS_GMRG/", "BinaryThresholdImageFilter", true, array(array(0, 30, 0, 255)));    	
        bp_apply_filter($pathData."cvPMS/cvBgr2Gr/itkBth/cvEro/itkMask/itkMask_PMS_GMRG/itkBth/", "cvVisResultsRgb", true, array(array(1)), $pathData."cvBgr2Gr/");    	
             
        bp_apply_filter($pathData."cvPMS/cvBgr2Gr/itkBth/cvEro/itkMask/", "itkMaskImageFilter", true, array(array(0)), $pathData."cvPMS/cvBgr2Gr/");
        shell_exec(str_replace($separatorNot, $separator, "move ".$pathData."cvPMS/cvBgr2Gr/itkBth/cvEro/itkMask/itkMask ".$pathData."cvPMS/cvBgr2Gr/itkBth/cvEro/itkMask/itkMask_PMS"));
        
    	break;
     case "PreProcMask2":
     	bp_apply_filter($pathData, "cvPyrMeanShiftFiltering", true, array(array(20, 40, 0)));
    	bp_apply_filter($pathData, "cvCvtColorBgr2Gray");
    	     	
    	bp_apply_filter($pathData."cvPMS/", "cvCvtColorBgr2Gray");
    	bp_apply_filter($pathData."cvPMS/cvBgr2Gr/", "GradientMagnitudeImageFilter");
    	bp_apply_filter($pathData."cvPMS/cvBgr2Gr/", "cvCanny", true, array(array(50,150,3)));    	
    	bp_apply_filter($pathData."cvPMS/cvBgr2Gr/", "itkCannyEdgeDetectionImageFilter", true, array(array(2.0,1,5)));    	
    	bp_apply_filter($pathData."cvPMS/cvBgr2Gr/", "BinaryThresholdImageFilter", true, array(array(0, 211, 0, 255)));
    	bp_apply_filter($pathData."cvPMS/cvBgr2Gr/itkBth/", "cvErode", true, array(array(3)));    	    	
        bp_apply_filter($pathData."cvPMS/cvBgr2Gr/itkBth/cvEro/", "cvVisResultsRgb", true, array(array(0)), $pathData."cvBgr2Gr/");
        shell_exec(str_replace($separatorNot, $separator, "move ".$pathData."cvPMS/cvBgr2Gr/itkBth ".$pathData."cvPMS/cvBgr2Gr/itkBth_1"));
        
      	bp_apply_filter($pathData."cvPMS/cvBgr2Gr/", "BinaryThresholdImageFilter", true, array(array(0, 146, 0, 255)));
    	bp_apply_filter($pathData."cvPMS/cvBgr2Gr/itkBth/", "cvDilate", true, array(array(3)));
        bp_apply_filter($pathData."cvPMS/cvBgr2Gr/itkBth/cvDil/", "cvVisResultsRgb", true, array(array(0)), $pathData."cvBgr2Gr/");
        shell_exec(str_replace($separatorNot, $separator, "move ".$pathData."cvPMS/cvBgr2Gr/itkBth ".$pathData."cvPMS/cvBgr2Gr/itkBth_2"));

        bp_apply_filter($pathData."cvPMS/cvBgr2Gr/itkBth_1/cvEro/", "itkMaskImageFilter", true, array(array(0)), $pathData."cvPMS/cvBgr2Gr/itkBth_2/cvDil/");             
        bp_apply_filter($pathData."cvPMS/cvBgr2Gr/itkBth_1/cvEro/itkMask/", "itkMaskImageFilter", true, array(array(0)), $pathData."cvPMS/cvBgr2Gr/itkGM/");    	
        shell_exec(str_replace($separatorNot, $separator, "move ".$pathData."cvPMS/cvBgr2Gr/itkBth_1/cvEro/itkMask/itkMask ".$pathData."cvPMS/cvBgr2Gr/itkBth_1/cvEro/itkMask/itkMask_PMS_GMRG"));

        bp_apply_filter($pathData."cvPMS/cvBgr2Gr/itkBth_1/cvEro/itkMask/", "itkMaskImageFilter", true, array(array(0)), $pathData."cvPMS/cvBgr2Gr/itkCanny/");  
        shell_exec(str_replace($separatorNot, $separator, "move ".$pathData."cvPMS/cvBgr2Gr/itkBth_1/cvEro/itkMask/itkMask ".$pathData."cvPMS/cvBgr2Gr/itkBth_1/cvEro/itkMask/itkMask_PMS_itkCanny"));
    	bp_apply_filter($pathData."cvPMS/cvBgr2Gr/itkBth_1/cvEro/itkMask/itkMask_PMS_itkCanny/", "cvDilate", true, array(array(1)));
        
        bp_apply_filter($pathData."cvPMS/cvBgr2Gr/itkBth_1/cvEro/itkMask/", "itkMaskImageFilter", true, array(array(0)), $pathData."cvPMS/cvBgr2Gr/cvCanny/");    	
        shell_exec(str_replace($separatorNot, $separator, "move ".$pathData."cvPMS/cvBgr2Gr/itkBth_1/cvEro/itkMask/itkMask ".$pathData."cvPMS/cvBgr2Gr/itkBth_1/cvEro/itkMask/itkMask_PMS_cvCanny"));
    	bp_apply_filter($pathData."cvPMS/cvBgr2Gr/itkBth_1/cvEro/itkMask/itkMask_PMS_cvCanny/", "cvDilate", true, array(array(1)));
    	        
    	bp_apply_filter($pathData."cvPMS/cvBgr2Gr/itkBth_1/cvEro/itkMask/itkMask_PMS_GMRG/", "BinaryThresholdImageFilter", true, array(array(0, 30, 0, 255)));    	
        bp_apply_filter($pathData."cvPMS/cvBgr2Gr/itkBth_1/cvEro/itkMask/itkMask_PMS_GMRG/itkBth/", "cvVisResultsRgb", true, array(array(1)), $pathData."cvBgr2Gr/");    	
             
        bp_apply_filter($pathData."cvPMS/cvBgr2Gr/itkBth_1/cvEro/itkMask/", "itkMaskImageFilter", true, array(array(0)), $pathData."cvPMS/cvBgr2Gr/");
        shell_exec(str_replace($separatorNot, $separator, "move ".$pathData."cvPMS/cvBgr2Gr/itkBth_1/cvEro/itkMask/itkMask ".$pathData."cvPMS/cvBgr2Gr/itkBth_1/cvEro/itkMask/itkMask_PMS"));
        
    	break;
     case "PreProcMask3":
     	bp_apply_filter($pathData, "cvPyrMeanShiftFiltering", true, array(array(20, 40, 0)));
    	bp_apply_filter($pathData, "cvCvtColorBgr2Gray");
    	     	
    	bp_apply_filter($pathData."cvPMS/", "cvCvtColorBgr2Gray");
    	//$path_filtered = "cvPMS/cvBgr2Gr/";
    	
    	bp_apply_filter($pathData."cvPMS/cvBgr2Gr/", "itkMedianImageFilter", true, array(array(5, 5)));
    	$path_filtered = "cvPMS/cvBgr2Gr/itkMedian/";
    	
    	bp_apply_filter($pathData.$path_filtered, "GradientMagnitudeImageFilter");
    	bp_apply_filter($pathData.$path_filtered, "cvCanny", true, array(array(50, 150, 3)));    	
    	bp_apply_filter($pathData.$path_filtered, "itkCannyEdgeDetectionImageFilter", true, array(array(0.1, 3, 7)));    	
    	bp_apply_filter($pathData.$path_filtered, "BinaryThresholdImageFilter", true, array(array(0, 205, 0, 255)));
    	bp_apply_filter($pathData.$path_filtered."itkBth/", "cvErode", true, array(array(3)));    	    	
        bp_apply_filter($pathData.$path_filtered."itkBth/cvEro/", "cvVisResultsRgb", true, array(array(0)), $pathData."cvBgr2Gr/");
        shell_exec(str_replace($separatorNot, $separator, "move ".$pathData.$path_filtered."itkBth ".$pathData.$path_filtered."itkBth_1"));
        
      	//bp_apply_filter($pathData."cvPMS/cvBgr2Gr/", "BinaryThresholdImageFilter", true, array(array(0, 146, 0, 255)));
    	//bp_apply_filter($pathData."cvPMS/cvBgr2Gr/itkBth/", "cvDilate", true, array(array(3)));
        //bp_apply_filter($pathData."cvPMS/cvBgr2Gr/itkBth/cvDil/", "cvVisResultsRgb", true, array(array(0)), $pathData."cvBgr2Gr/");
        //shell_exec(str_replace($separatorNot, $separator, "move ".$pathData."cvPMS/cvBgr2Gr/itkBth ".$pathData."cvPMS/cvBgr2Gr/itkBth_2"));

        //bp_apply_filter($pathData."cvPMS/cvBgr2Gr/itkBth_1/cvEro/", "itkMaskImageFilter", true, array(array(0)), $pathData."cvPMS/cvBgr2Gr/itkBth_2/cvDil/");             
        bp_apply_filter($pathData.$path_filtered."itkBth_1/cvEro/", "itkMaskImageFilter", true, array(array(0)), $pathData.$path_filtered."itkGM/");    	
        shell_exec(str_replace($separatorNot, $separator, "move ".$pathData.$path_filtered."itkBth_1/cvEro/itkMask ".$pathData.$path_filtered."itkBth_1/cvEro/itkMask_PMS_GMRG"));

        bp_apply_filter($pathData.$path_filtered."itkBth_1/cvEro/", "itkMaskImageFilter", true, array(array(0)), $pathData.$path_filtered."itkCanny/");  
        shell_exec(str_replace($separatorNot, $separator, "move ".$pathData.$path_filtered."itkBth_1/cvEro/itkMask ".$pathData.$path_filtered."itkBth_1/cvEro/itkMask_PMS_itkCanny"));
    	bp_apply_filter($pathData.$path_filtered."itkBth_1/cvEro/itkMask_PMS_itkCanny/", "cvDilate", true, array(array(1)));
        
        bp_apply_filter($pathData.$path_filtered."itkBth_1/cvEro/", "itkMaskImageFilter", true, array(array(0)), $pathData.$path_filtered."cvCanny/");    	
        shell_exec(str_replace($separatorNot, $separator, "move ".$pathData.$path_filtered."itkBth_1/cvEro/itkMask ".$pathData.$path_filtered."itkBth_1/cvEro/itkMask_PMS_cvCanny"));
    	bp_apply_filter($pathData.$path_filtered."itkBth_1/cvEro/itkMask_PMS_cvCanny/", "cvDilate", true, array(array(1)));
    	        
    	bp_apply_filter($pathData.$path_filtered."itkBth_1/cvEro/itkMask_PMS_GMRG/", "BinaryThresholdImageFilter", true, array(array(0, 30, 0, 255)));    	
        bp_apply_filter($pathData.$path_filtered."itkBth_1/cvEro/itkMask_PMS_GMRG/itkBth/", "cvVisResultsRgb", true, array(array(1)), $pathData."cvBgr2Gr/");    	
             
        bp_apply_filter($pathData.$path_filtered."itkBth_1/cvEro/", "itkMaskImageFilter", true, array(array(0)), $pathData.$path_filtered);
        shell_exec(str_replace($separatorNot, $separator, "move ".$pathData.$path_filtered."itkBth_1/cvEro/itkMask ".$pathData.$path_filtered."itkBth_1/cvEro/itkMask_PMS"));

    	bp_apply_filter($pathData.$path_filtered, "itkCannyEdgeDetectionImageFilterOrig", true, array(array(2.0, 5, 10)));     	   	
    	bp_apply_filter($pathData.$path_filtered."itkBth_1/cvEro/", "itkMaskImageFilter", true, array(array(0)), $pathData.$path_filtered."itkOrigCanny/");  
        shell_exec(str_replace($separatorNot, $separator, "move ".$pathData.$path_filtered."itkBth_1/cvEro/itkMask ".$pathData.$path_filtered."itkBth_1/cvEro/itkMask_PMS_itkOrigCanny_5_10"));

    	bp_apply_filter($pathData.$path_filtered, "itkCannyEdgeDetectionImageFilterOrig", true, array(array(2.0, 3, 7)));     	   	
    	bp_apply_filter($pathData.$path_filtered."itkBth_1/cvEro/", "itkMaskImageFilter", true, array(array(0)), $pathData.$path_filtered."itkOrigCanny/");  
        shell_exec(str_replace($separatorNot, $separator, "move ".$pathData.$path_filtered."itkBth_1/cvEro/itkMask ".$pathData.$path_filtered."itkBth_1/cvEro/itkMask_PMS_itkOrigCanny_3_7"));
        
    	break;   		
    	
    case "ThresClass2":
    	$pathData2 = $argv[3];
        bp_apply_filter($pathData, "BinaryThresholdImageFilter", true, array(array(0, 100, 0, 255)));
        bp_apply_filter($pathData."itkBth/", "cvVisResultsRgb", true, array(array(0)), $pathData2."cvBgr2Gr/"); 
        bp_apply_filter($pathData."itkBth/", "GradientMagnitudeImageFilter");
        bp_apply_filter($pathData."itkBth/itkGM/", "BinaryThresholdImageFilter", true, array(array(0, 1, 255, 0)));
        bp_apply_filter($pathData."itkBth/itkGM/itkBth/", "cvDilate"); 
        bp_apply_filter($pathData."itkBth/itkGM/itkBth/cvDil/", "cvVisResultsRgb", true, array(array(0)), $pathData2);                 
        
        bp_apply_filter($pathData."itkBth/", "itkClassifyConnectedComponents2", true, array(array(255, 15, 75, 1.35)));        
        bp_apply_filter($pathData."itkBth/itkClass2/", "cvVisResultsRgb", true, array(array(0)), $pathData2."cvBgr2Gr/"); 
        bp_apply_filter($pathData."itkBth/itkClass2/", "GradientMagnitudeImageFilter");
        bp_apply_filter($pathData."itkBth/itkClass2/itkGM/", "BinaryThresholdImageFilter", true, array(array(0, 1, 255, 0)));
        bp_apply_filter($pathData."itkBth/itkClass2/itkGM/itkBth/", "cvDilate"); 
        bp_apply_filter($pathData."itkBth/itkClass2/itkGM/itkBth/cvDil/", "cvVisResultsRgb", true, array(array(0)), $pathData2);                 
        break; 
    case "Class2":
    	$pathData2 = $argv[3];
        
        bp_apply_filter($pathData, "itkClassifyConnectedComponents2", true, array(array(255, 15, 75, 1.35)));        
        bp_apply_filter($pathData."itkClass2/", "cvVisResultsRgb", true, array(array(0)), $pathData2."cvBgr2Gr/"); 
        bp_apply_filter($pathData."itkClass2/", "GradientMagnitudeImageFilter");
        bp_apply_filter($pathData."itkClass2/itkGM/", "BinaryThresholdImageFilter", true, array(array(0, 1, 255, 0)));
        bp_apply_filter($pathData."itkClass2/itkGM/itkBth/", "cvDilate"); 
        bp_apply_filter($pathData."itkClass2/itkGM/itkBth/cvDil/", "cvVisResultsRgb", true, array(array(0)), $pathData2);                 
        break;         
    case "AdaptThresClass2":
        $pathData2 = $argv[3];     	
        bp_apply_filter($pathData, "cvAdaptiveThreshold", true, array(array(0, 151, 30)));
        bp_apply_filter($pathData."cvATh/", "BinaryThresholdImageFilter", true, array(array(0, 1, 0, 255)));
        bp_apply_filter($pathData."cvATh/itkBth/", "cvVisResultsRgb", true, array(array(0)), $pathData2."cvBgr2Gr/");        
        bp_apply_filter($pathData."cvATh/itkBth/", "GradientMagnitudeImageFilter");
        bp_apply_filter($pathData."cvATh/itkBth/itkGM/", "BinaryThresholdImageFilter", true, array(array(0, 1, 255, 0)));
        bp_apply_filter($pathData."cvATh/itkBth/itkGM/itkBth/", "cvDilate"); 
        bp_apply_filter($pathData."cvATh/itkBth/itkGM/itkBth/cvDil/", "cvVisResultsRgb", true, array(array(0)), $pathData2);
        
        bp_apply_filter($pathData."cvATh/itkBth/", "itkClassifyConnectedComponents2", true, array(array(255, 15, 75, 1.35))); 
        bp_apply_filter($pathData."cvATh/itkBth/itkClass2/", "cvVisResultsRgb", true, array(array(0)), $pathData2."cvBgr2Gr/"); 
        bp_apply_filter($pathData."cvATh/itkBth/itkClass2/", "GradientMagnitudeImageFilter");
        bp_apply_filter($pathData."cvATh/itkBth/itkClass2/itkGM/", "BinaryThresholdImageFilter", true, array(array(0, 1, 255, 0)));
        bp_apply_filter($pathData."cvATh/itkBth/itkClass2/itkGM/itkBth/", "cvDilate"); 
        bp_apply_filter($pathData."cvATh/itkBth/itkClass2/itkGM/itkBth/cvDil/", "cvVisResultsRgb", true, array(array(0)), $pathData2);
        //$pathData."../../../"*/
        break;
    case "CannyLevelSetClass2":
    	$pathData2 = $argv[3];
    	$pathData3 = $argv[4];    	
        bp_apply_filter($pathData, "itkCannySegmentationLevelSetImageFilterNoCannyTest", true, array(array(7, 0.1, -1.0, 1.0, -1.0, 128, 3000)), $pathData2);
        bp_apply_filter($pathData."itkCannyLS/", "cvVisResultsRgb", true, array(array(0)), $pathData3."cvBgr2Gr/");            	
        bp_apply_filter($pathData."itkCannyLS/", "GradientMagnitudeImageFilter");
        bp_apply_filter($pathData."itkCannyLS/itkGM/", "BinaryThresholdImageFilter", true, array(array(0, 1, 255, 0)));
        bp_apply_filter($pathData."itkCannyLS/itkGM/itkBth/", "cvDilate"); 
        bp_apply_filter($pathData."itkCannyLS/itkGM/itkBth/cvDil/", "cvVisResultsRgb", true, array(array(0)), $pathData3);

        bp_apply_filter($pathData."itkCannyLS/", "itkClassifyConnectedComponents2", true, array(array(255, 15, 75, 1.35))); 
        bp_apply_filter($pathData."itkCannyLS/itkClass2/", "cvVisResultsRgb", true, array(array(0)), $pathData3."cvBgr2Gr/"); 
        bp_apply_filter($pathData."itkCannyLS/itkClass2/", "GradientMagnitudeImageFilter");
        bp_apply_filter($pathData."itkCannyLS/itkClass2/itkGM/", "BinaryThresholdImageFilter", true, array(array(0, 1, 255, 0)));
        bp_apply_filter($pathData."itkCannyLS/itkClass2/itkGM/itkBth/", "cvDilate"); 
        bp_apply_filter($pathData."itkCannyLS/itkClass2/itkGM/itkBth/cvDil/", "cvVisResultsRgb", true, array(array(0)), $pathData3);
        
    	break;         

    case "Visualize":
    	$pathData2 = $argv[3];
        bp_apply_filter($pathData, "GradientMagnitudeImageFilter");
        bp_apply_filter($pathData."itkGM/", "BinaryThresholdImageFilter", true, array(array(0, 1, 255, 0)));
        bp_apply_filter($pathData."itkGM/itkBth/", "cvDilate"); 
        bp_apply_filter($pathData."itkGM/itkBth/cvDil/", "cvVisResultsRgb", true, array(array(0)), $pathData2);    	
    	break; 
    case "itkCannySegmentationLevelSetImageFilterNoCannyTest":   	            
    case "cvVisResultsRgb":
    case "itkMaskImageFilter":    	
        $pathData2 = $argv[3];  
        bp_apply_filter($pathData, $filterName, true, array(array($argv[4])), $pathData2);       
        break;  
    default:
    	if($argc>3)
    	{
    		for ($i = 3; $i <= $argc; $i++) $ps[] = $argv[$i];
    	  //var_dump($ps);
    	  //var_dump($argv);
       	  bp_apply_filter($pathData, $filterName, true, array($ps));    	
    	}    	    	    	
    	else bp_apply_filter($pathData, $filterName);
}

?>
