<?php 

/******************************************************************************
*
*   This file is part of the software tool "Cervix Image Processing 2 (CIP2)".
*
*   Author: Christoph Bergmeir
*   Supervisor: José M. Benítez
*   Copyright (c) DiCITS Lab, Sci2s group, DECSAI, University of Granada.
*
*   This program is free software; you can redistribute it and/or
*   modify it under the terms of the GNU General Public License
*   as published by the Free Software Foundation; either version 2
*   of the License, or (at your option) any later version.
*   
*   This program is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*   
*   You should have received a copy of the GNU General Public License
*   along with this program; if not, write to the Free Software
*   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
*   MA  02110-1301, USA.
*
******************************************************************************/

require("connect.php");
require ("process_large_image.php");

$idSpecimen = 0 + $argv[1];
$pathSpecimen = $argv[2]; //e.g. $pathSpecimen = 6671_jpeg

$idWorkCollection = 0 + $argv[3];
$pathWorkCollection = $argv[4]; //e.g. "PRN/"

$nameFilter = $argv[5]; //e.g. "ATh"
$pathFilter = $argv[6]; //e.g. "ATh/"

$fullTiffFilename = "$pathSlideData$pathSpecimen/$pathSpecimen$postfixFullSlide";
$regionDefinitionFile = "$pathSlideData$pathSpecimen/work_collections/$pathWorkCollection$filenameExportedRegions";

$pathWorkCollections = "$pathSlideData$pathSpecimen/work_collections/";
$pathCurrentWorkCollection = "$pathWorkCollections$pathWorkCollection";
$pathExtractRegions = $pathCurrentWorkCollection . "regions/";
$pathFilterResults = $pathCurrentWorkCollection . "filter_results/";
$pathCurrentFilterResult = "$pathFilterResults$pathFilter";

//shell_exec(str_replace($separatorNot, $separator, "mkdir $pathWorkCollections"));
//shell_exec(str_replace($separatorNot, $separator, "mkdir $pathCurrentWorkCollection"));
shell_exec(str_replace($separatorNot, $separator, "mkdir $pathExtractRegions"));
shell_exec(str_replace($separatorNot, $separator, "mkdir $pathFilterResults"));
shell_exec(str_replace($separatorNot, $separator, "mkdir $pathCurrentFilterResult"));

echo $fullTiffFilename."\n";
echo $regionDefinitionFile."\n";
echo $pathWorkCollections."\n";
echo $pathCurrentWorkCollection."\n";
echo $pathExtractRegions."\n";
echo $pathFilterResults."\n";
echo $pathCurrentFilterResult."\n";

function setProgress($progress)
{
  global $pathCurrentWorkCollection;
  
  $fh = fopen("$pathCurrentWorkCollection.state", 'w') or die("can't open state file for writing..");
  fwrite($fh, "$progress");  
  fclose($fh);
}

setProgress(0);

extractRegions($fullTiffFilename, $regionDefinitionFile, $pathExtractRegions);

setProgress(33);

//-------------------------------
// Filtering
//-------------------------------

bp_apply_filter($pathExtractRegions, "cvCvtColorBgr2Gray");
bp_apply_filter($pathExtractRegions."cvBgr2Gr/", "cvAdaptiveThreshold", true, array(array(0, 151, 30)));
$pathInsertRegions = $pathExtractRegions."cvBgr2Gr/cvATh/";
//-------------------------------

$pathTiles = $pathCurrentFilterResult . "tiles/";     

setProgress(67); 
      
generateTiles($fullTiffFilename, $pathTiles, true, true, $pathInsertRegions, true);

$query = "INSERT INTO filter_results(id, id_work_collection, name, date, comment, path, parameters) VALUES (NULL , '$idWorkCollection', '$nameFilter', '" . 
                                                            date('Y-m-d') . "', '', '$pathFilter', '')";
print $query;

$result=mysql_query($query);
if(mysql_errno($connection)==0)
{
  print "Dataset was inserted</br>";
}
else
{
  if(mysql_errno($connection)==1062)
    print "Double primary key, couldn't insert</br>";
  else
  {
    $numERROR=mysql_errno($connection);
    $description=mysql_errno($connection);
    print "An error occured: $numERROR Description: $description </br>";
  };
}
  
setProgress(-1);  

?>
