<?php

/******************************************************************************
*
*   This file is part of the software tool "Cervix Image Processing 2 (CIP2)".
*
*   Author: Christoph Bergmeir
*   Supervisor: José M. Benítez
*   Copyright (c) DiCITS Lab, Sci2s group, DECSAI, University of Granada.
*
*   This program is free software; you can redistribute it and/or
*   modify it under the terms of the GNU General Public License
*   as published by the Free Software Foundation; either version 2
*   of the License, or (at your option) any later version.
*   
*   This program is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*   
*   You should have received a copy of the GNU General Public License
*   along with this program; if not, write to the Free Software
*   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
*   MA  02110-1301, USA.
*
******************************************************************************/

//require ("configure.php");
require("bp_apply_filter.php");

function splitSvsImage($inSvsFilename)
{
  global $postfixFullSlide, $postfixThumbnail, $pathCodeOwn, $pathCodeImagemagick, $separatorNot, $separator;

  //if (!ends_with($inSvsFilename, ".svs") && !ends_with($inSvsFilename, ".SVS")) return; 
 
  $inSvsFilePathNoEnding = substr($inSvsFilename, 0, -4);
  $inSvsFilenameNoEnding = basename($inSvsFilePathNoEnding);
  
  shell_exec(str_replace($separatorNot, $separator, "mkdir $inSvsFilePathNoEnding"));
  
  $fullTiffFilename = "$inSvsFilePathNoEnding/$inSvsFilenameNoEnding$postfixFullSlide";
  
  shell_exec("tiffsplit $inSvsFilename $inSvsFilePathNoEnding/");
  shell_exec("mv $inSvsFilePathNoEnding/aaa.tif $fullTiffFilename");
  shell_exec("mv $inSvsFilePathNoEnding/aab.tif $inSvsFilePathNoEnding/$inSvsFilenameNoEnding" . "_thumbnail.tif");
  
  //-------------------------------------------------
  $dirHandle = @opendir($inSvsFilePathNoEnding) or die("Unable to open $inSvsFilePathNoEnding"); 

  $splitResultFiles = array();

  while (false !== ($file = readdir($dirHandle))) 
  {
    //if($file == "." || $file == "..") continue;
    if(!begins_with($file, "a")) continue;
    if(!ends_with($file, ".tif")) continue;
    
    //if(is_dir("$pathIncomingCollections$file")) 
    $splitResultFiles[] = $file;
    echo "$file\n";
  }
  
  natsort($splitResultFiles);
  
  $num = count($splitResultFiles);
 
  shell_exec("mv $inSvsFilePathNoEnding/".$splitResultFiles[$num-2]." $inSvsFilePathNoEnding/$inSvsFilenameNoEnding" . "_code.tif");
  shell_exec("mv $inSvsFilePathNoEnding/".$splitResultFiles[$num-1]." $inSvsFilePathNoEnding/$inSvsFilenameNoEnding" . "_localizer.tif");
      
  //-------------------------------------------------
  shell_exec("rm $inSvsFilePathNoEnding/aa*.tif");

  shell_exec("$pathCodeImagemagick" . "convert -rotate 90 $inSvsFilePathNoEnding/$inSvsFilenameNoEnding" . "_code.tif $inSvsFilePathNoEnding/$inSvsFilenameNoEnding" . "_code.jpg");
    
  shell_exec("$pathCodeImagemagick" . "convert $inSvsFilePathNoEnding/$inSvsFilenameNoEnding" . "_thumbnail.tif $inSvsFilePathNoEnding/$inSvsFilenameNoEnding" . "_thumbnail.jpg");
  //shell_exec("$pathCodeImagemagick" . "convert $inSvsFilePathNoEnding/$inSvsFilenameNoEnding" . "_code.tif $inSvsFilePathNoEnding/$inSvsFilenameNoEnding" . "_code.jpg");
  shell_exec("$pathCodeImagemagick" . "convert $inSvsFilePathNoEnding/$inSvsFilenameNoEnding" . "_localizer.tif $inSvsFilePathNoEnding/$inSvsFilenameNoEnding" . "_localizer.jpg");
     
  return $fullTiffFilename; 
}

function extractRegions($fullTiffFilename, $regionDefinitionFile, $pathExtractRegions)
{
  global $pathCodeVipsIo;
  
  //echo $pathCodeVipsIo . "extractImagesVipsMarkers $fullTiffFilename $regionDefinitionFile $pathExtractRegions";
  echo shell_exec($pathCodeVipsIo . "extractImagesVipsMarkers $fullTiffFilename $regionDefinitionFile $pathExtractRegions");
}

function generateTiles($fullTiffFilename, $pathTiles, $convertRegionsFormat=false, $convertRegionsGs2Bgr=false, $pathInsertRegions="0", $retile=false, $shrinkTiles=false, $oldNamingFormat=false)
{
  global $pathCodeVipsIo, $separatorNot, $separator;
  
  if($pathInsertRegions != "0")
  {
    if($convertRegionsGs2Bgr)
    {
      bp_apply_filter($pathInsertRegions, "cvCvtGray2ColorBgr");
      $pathInsertRegions = $pathInsertRegions . "cvGr2Bgr/";
    }
    if($convertRegionsFormat)
    {
      bp_apply_filter($pathInsertRegions, "cvConv");
      $pathInsertRegions = $pathInsertRegions . "cvConv/";
    }
  }
    
  shell_exec(str_replace($separatorNot, $separator, "mkdir $pathTiles"));
    
  if($shrinkTiles) $s = "1"; else $s="0";
  if($retile) $r = "1"; else $r="0";
  if($oldNamingFormat) $onf = "1"; else $onf="0";
    
  print($pathCodeVipsIo . "insertImagesVips $fullTiffFilename ./debug.jpg $pathInsertRegions $pathTiles $s $r $onf </br>");
  shell_exec($pathCodeVipsIo . "insertImagesVips $fullTiffFilename ./debug.jpg $pathInsertRegions $pathTiles $s $r $onf"); 
}

?>
